# SRecord class:
# Take in an integer address and variable length chunks of hex data.
# Then save them in equal length records in a list with any leftovers
# on their own line and a termination record on its own line.

from MyTypes import filelist

class SRecord(filelist):
    def __init__(self):
        list.__init__([])
        self.nxtadd = 0         # Get this address next else EndLine(), StartLine(address)
        self.curlen = 0         # The current number if data bytes in the current line
        self.myline = ''        # The current line being built
        self.length = 34        # length of address (2) + data fild

    def EndLine(self, line):
        line = hex(self.curlen + 1)[2:].upper().zfill(2) + line
        tot = 0
        for i in range(0,len(line),2):
            tot += int(line[i:i+2],16)
        self.append('S1' + line + hex(~(tot & 0xFF) + 256)[2:].upper().zfill(2) + '\n')
        self.myline = ''

    def StartLine(self, address):
        if not self.myline:
            self.myline = hex(address)[2:].upper().zfill(4)
            self.curlen = 2

    def EndS19(self):
        if self.myline:
            self.EndLine(self.myline)
        self.append('S9030000FC\n')
        self.nxtadd = 0 

    def AddBytes(self, address, hexdata):
        if address != self.nxtadd:
            if self.myline:
                self.EndLine(self.myline)
            self.nxtadd = address
        self.StartLine(address)
        addlen = len(hexdata)/2
        self.nxtadd += addlen
        if self.curlen + addlen < self.length:
            self.curlen += addlen
            self.myline += hexdata
        else:
            canadd = self.length - self.curlen
            self.curlen = self.length
            self.EndLine(self.myline + hexdata[:canadd * 2])
            a = addlen - canadd
            self.StartLine(address + (canadd))
            self.curlen += a
            self.myline += hexdata[canadd * 2:]
