from Tkinter import *
from BCDbaseDialog import baseDialog

class progressDialog(baseDialog):

    def __init__(self, root, label=""):
        baseDialog.__init__(self, root, title='Progress', label=label)
        self.canceled = False

    def CreateWidgets(self, top, label):
        self.frameMain = frameMain = Frame(top, bg=self.bg, borderwidth=2, relief=SUNKEN)
        Label(frameMain, bg=self.bg, text=label, width=24
              ).grid(row=0, column=0, sticky=EW, columnspan=6, padx=5, pady=10)

        self.meter_x = meter_x = 2
        self.meter_len = meter_len = 244
        self.meter = meter = Canvas(frameMain, bg=self.bg, width=meter_len, height=18)
        meter.grid(row=1, column=0, sticky=EW, columnspan=6, padx=20, pady=5)
        self.rect = meter.create_rectangle(2, 2, meter_x, 20, fill="black")

        button = Button(frameMain, text='Cancel', command=self.Cancel, takefocus=0)
        button.grid(row=2, column=5, sticky=EW, columnspan=1, padx=15, pady=10)
        frameMain.grid(row=0, column=0) # I tried to get rid of flashing here

    def Cancel(self, event=None):
        self.close()

    def Run(self, progress):
        delta_p = progress - self.oldprog
        if delta_p >= self.delta_p:
            self.oldprog = progress
            self.meter_x += self.delta_x
            self.meter.coords(self.rect, 2, 2, self.meter_x, 20)
            self.top.update()
        return self.canceled

    def SetMax(self, count):
        self.count = count
        if count > self.meter_len:
            self.delta_x = 1
            self.delta_p = count//self.meter_len + 1
        else:
            self.delta_p = 1
            self.delta_x = self.meter_len//count
        self.oldprog = 0


    def close(self, event=None):
        self.canceled = True
        self.top.destroy()

##################################

    def AddTestButton(self):
        button = Button(self.frameMain, text='test', command=self.test, takefocus=0)
        button.grid(row=2, column=0, sticky=EW, columnspan=1, padx=15, pady=10)

    def test(self):
        from time import sleep
        import tkSimpleDialog
        count = tkSimpleDialog.askinteger('Test', 'How many times?', parent=self.top)
        self.SetMax(count)
        st = max(1.0/count * 2, .001)
        for loop in range(count):
            canceled = self.Run(loop)
            if canceled:
                print 'canceled'
                break
            sleep(st)
        if not canceled:
            self.close()
        root.destroy()


if __name__ == '__main__':
    # test the dialog
    root = Tk()
    testDialog = progressDialog(root, 'Cross Referencing')
    testDialog.AddTestButton()
    root.mainloop()
#    root.destroy()
